application.css imported by themes not covered by cache control versioning
Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Themes Estimated time: 0.00 hour
Target version:

Resolution: Fixed Affected version: 3.4.6
Description

The subject and #24617-12 pretty much says it all.

After an update, the old application.css still gets used by browsers' caches, with no means other than renaming the file and its import
statements in the used theme to force cache invalidation.

Partial workaround:
public/themes/<activetheme>/stylesheets/application.css

Change import statement
@import url(../../../stylesheets/application.css);

to some other name (e.g. application_v2.css)

Rename public/stylesheets/application.css to e.g. application_v2.css

Also apply the cache control hack in the mentioned ticket.

However, you can still never go back to application.css as browsers will still keep it cached forever. A fix is needed that makes the
filename unique on every update, much like all other resources.

This may also affect other resources delivered by themes (e.g. images), so a best practice should be given for how to avoid that as
well.

Related issues:

Related to Redmine - Defect #24617: Browser js/css cache remains after upgrade Closed
Related to Redmine - Feature #39111: Enable Asset Pipeline Integration using ... Closed
History

#1 - 2018-09-18 01:28 - Go MAEDA

- Subject changed from application.css not covered by cache control versioning to application.css imported by themes not covered by cache control
versioning

- Category set to Themes

#2 - 2018-09-18 01:28 - Go MAEDA

- Related to Defect #24617: Browser js/css cache remains after upgrade added

#3 - 2019-03-15 15:44 - Yuuki NARA

+1

| think this information should be known more.

#4 - 2021-11-05 21:48 - Jonathan Cormier

Change import statement
@import url(../../../stylesheets/application.css);

to some other name (e.g. application_v2.css)

Rename public/stylesheets/application.css to e.g. application_v2.css
https://www.redmine.org/issues/24617#note-12

A "better" workaround is to append a ?version tag instead of renaming the file, that way you don't have to modify redmine internal files. The downside
still being that you have to remember to update your theme everytime you upgrade redmine..

Example:

@import url(../../../stylesheets/application.css?4.3.2);

So | also modified the cache directive from https://www.redmine.org/projects/redmine/wiki/BrowserCaching#The-work-round-for-RedMine

| decided to stop caching any files which don't have the ?version tags. At least on redmine 4.2.3, the vast majority of the files have this tag. Only
leaving out a few images which are loaded from application.css

- # the regex logic: after either /Jjavascripts/ or /stylesheets/ find the suffixes we want, followed by any g
uantity of numbers 0-9
+ # the regex logic: after either /javascripts/ or /stylesheets/ find the suffixes we want, followed by one o
r more numbers 0-9

# This works because the files we want to cache always appear after one of those 2 directories: but not th
e files we want to ignore

# /journals/edit/24174.3js and /uploads.js?attachment_id=1&filename=my-file-to-upload.png
— location ~* {{REDMINE_RELATIVE_URL_ROOT}} (?<file>/ (?:(?:plugin_assets/|themes/) .+)? (?:javascripts|styleshee
ts|images|favicon)/.+(?:css|jsljpe?glgif|icolpng|html) (\?2[0-9]1+)2$) {
+ location ~* {{REDMINE_RELATIVE_URL_ROOT}} (?<file>/(?:(?:plugin_assets/|themes/) .+)?(?:Jjavascripts|styleshee
ts|images|favicon)/.+(?:css|Js|Jjpe?glgiflicolpng|/html) (\?2[0-9]1+)$) {

#5 - 2024-10-14 08:58 - Go MAEDA
- Status changed from New to Closed

- Resolution set to Fixed

I am closing this issue as it has been addressed with the introduction of Propshaft in #39111.
The file name for application.css now includes a unique hash, such as application-d6f7411e86b2ce8420acd27cf33d18c838c5f975.css. The hash will

change whenever application.css is updated, ensuring that outdated cached files are not improperly used. Third-party themes that import
application.css via @import URL(...) will also benefit from this versioning behavior.

#6 - 2024-10-14 08:59 - Go MAEDA
- Related to Feature #39111: Enable Asset Pipeline Integration using Propshaft added
